#include <stdio.h>
#include <string.h>

#define ROWS 8
#define MAX_LEN 20

void read_input(char buffer[][MAX_LEN]) {
	int i;
	char format_str[15];
	
	sprintf(format_str, "%%%ds", MAX_LEN-1);
	
	printf("Enter input\n");
	for (i = 0; i < ROWS; i++) {
		scanf(format_str, buffer[i]);
	}
}

void print_array(char buffer[][MAX_LEN]) {
	int i;
	
	printf("Data:\n");
	for (i = 0; i < ROWS; i++) {
		printf("%s\n", buffer[i]);
	}
}

void swap (char *num1, char *num2) {
	char temp[MAX_LEN];
	strcpy(temp, num1);
	strcpy(num1, num2);
	strcpy(num2, temp);
}

void selection_sort(char buffer[][MAX_LEN]) {
	int pos, min_pos, i;
	
	for (pos = 0; pos < ROWS-1; pos++) {
		printf("Looking for proper string for position %d. Looking at positions %d to %d\n", pos, pos, ROWS-1);
		min_pos = pos;
		for (i = pos+1; i < ROWS; i++) {
			if (strcmp(buffer[i], buffer[min_pos]) < 0) {
				min_pos = i;
			}
		}
		printf("Element in %d is the smallest. Putting it in pos %d\n", min_pos, pos);
		if (pos != min_pos) {
			swap(buffer[pos], buffer[min_pos]);
		}
	}
}

int main (int argc, char *argv[]) {
	char data[ROWS][MAX_LEN];
	
	read_input(data);
	print_array(data);

	selection_sort(data);

	print_array(data);
	return(0);
}
