#include <stdio.h>

#define ROWS 8

void read_input(int buffer[]) {
	int i;
	
	printf("Enter input\n");
	for (i = 0; i < ROWS; i++) {
		scanf("%d", &buffer[i]);
	}
}

void print_array(int buffer[]) {
	int i;
	
	printf("Data:\n");
	for (i = 0; i < ROWS; i++) {
		printf("%d\n", buffer[i]);
	}
}


int linear_search(int buffer[], int elem, int array_size) {
	int i;
	
	for (i = 0; i < array_size; i++) {
		if (elem == buffer[i])
			return(i);
	}
	/* We reached the end of the array and we did not find the element */
	return(-1);
}

int main (int argc, char *argv[]) {
	int data[ROWS];
	int search_elem, pos;
	
	read_input(data);
	print_array(data);
	
	printf("Element to look for:\n");
	scanf("%d", &search_elem);
	
	pos = linear_search(data, search_elem, ROWS);
	
	if (pos != -1) {
		printf("Element %d found at position %d\n", search_elem, pos);
	}
	else {
		printf("Element %d not found\n", search_elem);
	}
	
	return(0);
}
