#include <stdio.h>

#define ROWS 8

void read_input(int buffer[]) {
	int i;
	
	printf("Enter input\n");
	for (i = 0; i < ROWS; i++) {
		scanf("%d", &buffer[i]);
	}
}

void print_array(int buffer[]) {
	int i;
	
	printf("Data:\n");
	for (i = 0; i < ROWS; i++) {
		printf("%d\n", buffer[i]);
	}
}

void swap (int *num1, int *num2) {
	int temp;
	temp = *num1;
	*num1 = *num2;
	*num2 = temp;
}

void selection_sort(int buffer[]) {
	int pos, min_pos, i;
	
	for (pos = 0; pos < ROWS-1; pos++) {
		printf("Looking for proper number for position %d. Looking at positions %d to %d\n", pos, pos+1, ROWS-1);
		min_pos = pos;
		for (i = pos+1; i < ROWS; i++) {
			if (buffer[i] < buffer[min_pos]) {
				min_pos = i;
			}
		}
		printf("Element in %d is the smallest. Putting it in pos %d\n", min_pos, pos);
		if (pos != min_pos) {
			swap(&buffer[pos], &buffer[min_pos]);
		}
	}
}

int main (int argc, char *argv[]) {
	int data[ROWS];
	
	read_input(data);
	print_array(data);

	selection_sort(data);

	print_array(data);
	return(0);
}
